/*global Encoder,TW */

var TW_barChartIsExtension;

(function () {

    var addedDefaultChartStyles = false;

    TW.Runtime.Widgets.barChart = function () {
        var thisWidget = this,
            liveData,
            widgetProperties,
            widgetContainer,
            widgetContainerId,
            chartContainer,
            chartContainerId,
            chart,
            emptyChart,
            purge,
            chartData,
            chartSeries = [],
            MAX_SERIES = 8,
            chartStyles = {},
            returnData = [],
            dataLabels = [],
            dataRows,
            dataRowsNum,
            valueUnderMouse = {},
            clickedRowId,
            selectedRowIndices,
            chartTitleTextSizeClass,
            chartTitleStyle,
            stackable = true,
            isResponsive = false,
            isInHiddenTab = false,
            isInHiddenBrowserTab,
            barLabels,
            resizeHandler;

        thisWidget.processing = false;
        thisWidget.singleDataSource = thisWidget.getProperty('SingleDataSource');
        thisWidget.nSeries = Math.min(MAX_SERIES, thisWidget.getProperty('NumberOfSeries'));
        thisWidget.title = thisWidget.getProperty('ChartTitle');
        thisWidget.titleAlignment = thisWidget.getProperty("ChartTitleAlignment");
        thisWidget.xAxisLabel = thisWidget.getProperty('X-AxisLabel');
        thisWidget.yAxisLabel = thisWidget.getProperty('Y-AxisLabel');
        thisWidget.xAxisField = thisWidget.getProperty('X-AxisField');
        thisWidget.showAxisLabels = thisWidget.getProperty('ShowAxisLabels');
        thisWidget.showXAxisLabels = Boolean(thisWidget.getProperty('ShowX-AxisLabels'));
        thisWidget.showYAxisLabels = Boolean(thisWidget.getProperty('ShowY-AxisLabels'));
        // don't set these to object props they are dynamic!
        thisWidget.showZoomStrip = thisWidget.getProperty('ShowZoomStrip');
        thisWidget.useInteractiveGuideline = thisWidget.getProperty('UseInteractiveGuideline');
        thisWidget.showLegend = thisWidget.getProperty('ShowLegend');
        thisWidget.duration = thisWidget.getProperty('Duration');
        thisWidget.labelAngle = thisWidget.getProperty('LabelAngle')*-1;
        thisWidget.xAxisIntervals = thisWidget.getProperty('X-AxisIntervals');
        thisWidget.xAxisMinMaxVisible = Boolean(thisWidget.getProperty('ShowX-AxisMinMax'));
        thisWidget.yAxisMinimum = thisWidget.getProperty('Y-AxisMinimum')*1;
        thisWidget.yAxisMaximum = thisWidget.getProperty('Y-AxisMaximum')*1;
        thisWidget.autoScale = Boolean(thisWidget.getProperty('AutoScale'));
        thisWidget.enableHover = Boolean(thisWidget.getProperty('EnableHover'));
        thisWidget.showValues = Boolean(thisWidget.getProperty('ShowValues'));
        thisWidget.yAxisIntervals = thisWidget.getProperty('Y-AxisIntervals');
        thisWidget.precision = Math.max(thisWidget.getProperty('ShowValuesFormat'),0);
        thisWidget.yAxisMinMaxVisible = thisWidget.getProperty('ShowY-AxisMinMax');
        thisWidget.margins = thisWidget.getProperty('Margins');
        thisWidget.width = thisWidget.getProperty('Width');
        thisWidget.height = thisWidget.getProperty('Height');
        thisWidget.zIndex = thisWidget.getProperty('Z-index');
        thisWidget.selectedItems = [];
        thisWidget.enableSelection = true;

        (function () {
            var hidden = "hidden";
            // Standards:
            if (hidden in document) {
                document.addEventListener("visibilitychange", onchange);
            } else if ((hidden = "mozHidden") in document) {
                document.addEventListener("mozvisibilitychange", onchange);
            } else if ((hidden = "webkitHidden") in document) {
                document.addEventListener("webkitvisibilitychange", onchange);
            } else if ((hidden = "msHidden") in document) {
                document.addEventListener("msvisibilitychange", onchange);
            }

            function onchange(evt) {
                var v = "visible", h = "hidden",
                    evtMap = { focus: v,focusin: v,pageshow: v,blur: h,focusout: h,pagehide: h};
                evt = evt || window.event;
                if (evt.type in evtMap) {
                    document.body.className = evtMap[evt.type];
                    isInHiddenBrowserTab = evtMap[evt.type].charAt(0)==="h";
                } else {
                    document.body.className = this[hidden] ? "hidden" : "visible";
                    isInHiddenBrowserTab = this[hidden];
                }
            }

            // set the initial state (but only if browser supports the Page Visibility API)
            if (document[hidden] !== undefined) {
                onchange({type: document[hidden] ? "blur" : "focus"});
            }
        })();

        this.runtimeProperties = function () {
            return {
                'needsDataLoadingAndError': false
            };
        };

        this.renderHtml = function () {
            chartTitleStyle = TW.getStyleFromStyleDefinition(thisWidget.getProperty('ChartTitleStyle', 'DefaultChartStyle'));

            chartTitleTextSizeClass = 'textsize-normal';
            if (this.getProperty('ChartTitleStyle') !== undefined) {
                chartTitleTextSizeClass = TW.getTextSizeClassName(chartTitleStyle.textSize);
            }

            thisWidget.id = +thisWidget.getProperty('Id');
            var html =
                '<div class="timeSeriesChartV2-content widget-timeSeriesChartV2" id="' + thisWidget.jqElementId + '" >' +
                '<div class="chart-title ' + chartTitleTextSizeClass + '" id="' + thisWidget.jqElementId + '-title" style=" text-align:' + (thisWidget.titleAlignment || 'center') + ';">' +
                    '<span class="widget-chart-title-text" style="Margin: 0 1em 0 1em;">'+ Encoder.htmlEncode(thisWidget.title) + '</span>' +
                '</div>' +
                '</div>';

            // if running as extension, call renderStyles
            if (TW_barChartIsExtension){
                thisWidget.renderStyles();
            }

            return html;
        };

        this.renderStyles = function () {

            var formatResult = TW.getStyleFromStyleDefinition(thisWidget.getProperty('ChartBodyStyle', 'DefaultChartBodyStyle'));
            chartTitleStyle = TW.getStyleFromStyleDefinition(thisWidget.getProperty('ChartTitleStyle', 'DefaultChartTitleStyle'));
            var chartAxisStyle = TW.getStyleFromStyleDefinition(thisWidget.getProperty('ChartAxisStyle', 'DefaultChartAxisStyle'));
            var chartTitleStyleBG = TW.getStyleCssGradientFromStyle(chartTitleStyle);
            var chartTitleStyleText = TW.getStyleCssTextualNoBackgroundFromStyle(chartTitleStyle);
            var chartBackground = TW.getStyleCssGradientFromStyle(formatResult);
            var chartBorder = TW.getStyleCssBorderFromStyle(formatResult);
            var chartAxisStyleText = TW.getStyleCssTextualNoBackgroundFromStyle(chartAxisStyle);
            // chart series lines are stroked in color in svg processing, not in css
            // to be replaced with iterator on however many series/styles were set up
            var chartStyle1 = TW.getStyleFromStyleDefinition(thisWidget.getProperty('SeriesStyle1','DefaultChartStyle1'));
            var chartStyle2 = TW.getStyleFromStyleDefinition(thisWidget.getProperty('SeriesStyle2','DefaultChartStyle2'));
            var chartStyle3 = TW.getStyleFromStyleDefinition(thisWidget.getProperty('SeriesStyle3','DefaultChartStyle3'));
            var chartStyle4 = TW.getStyleFromStyleDefinition(thisWidget.getProperty('SeriesStyle4','DefaultChartStyle4'));
            var chartStyle5 = TW.getStyleFromStyleDefinition(thisWidget.getProperty('SeriesStyle5','DefaultChartStyle5'));
            var chartStyle6 = TW.getStyleFromStyleDefinition(thisWidget.getProperty('SeriesStyle6','DefaultChartStyle6'));
            var chartStyle7 = TW.getStyleFromStyleDefinition(thisWidget.getProperty('SeriesStyle7','DefaultChartStyle7'));
            var chartStyle8 = TW.getStyleFromStyleDefinition(thisWidget.getProperty('SeriesStyle8','DefaultChartStyle8'));
            chartStyles.series1 = chartStyle1.foregroundColor;
            chartStyles.series2 = chartStyle2.foregroundColor;
            chartStyles.series3 = chartStyle3.foregroundColor;
            chartStyles.series4 = chartStyle4.foregroundColor;
            chartStyles.series5 = chartStyle5.foregroundColor;
            chartStyles.series6 = chartStyle6.foregroundColor;
            chartStyles.series7 = chartStyle7.foregroundColor;
            chartStyles.series8 = chartStyle8.foregroundColor;
            var styleBlock = '';

            var chartCssInfo = TW.getStyleCssTextualNoBackgroundFromStyle(formatResult);
            var chartLineInfo = TW.getStyleCssBorderFromStyle(chartAxisStyle);
            //var chartFocusBorder = TW.getStyleCssBorderFromStyle(chartFocusStyle);

            // for d3 style assignments
            chartStyles.text = chartCssInfo.split(';')[0].split(':')[1];
            chartStyles.gridStyle = chartLineInfo.split(';')[1].split(':')[1];
            chartStyles.axisFontWeight = chartAxisStyleText.split(';')[0].split(':')[1];

            //regular widget styles
            if (thisWidget.getProperty('ChartBodyStyle', 'DefaultChartBodyStyle') === 'DefaultChartBodyStyle'
                && thisWidget.getProperty('ChartTitleStyle', 'DefaultChartTitleStyle') === 'DefaultChartTitleStyle'
                && thisWidget.getProperty('FocusStyle', 'DefaultButtonFocusStyle') === 'DefaultButtonFocusStyle') {
                if (!addedDefaultChartStyles) {
                    addedDefaultChartStyles = true;
                    // add chart title default style
                    var defaultStyles = '.chart-title {' + chartTitleStyleBG + ' ' + chartTitleStyleText + ' }' +
                    //  ' .widget-barChart.focus {' + chartFocusBorder + '}' +
                        ' .widget-barChart {' + chartBackground + '}';
                    $.rule(defaultStyles).appendTo(TW.Runtime.globalWidgetStyleEl);
                }
            } else {
                // add custom chart title style
                styleBlock += '#' + thisWidget.jqElementId + ' .chart-title { ' + chartTitleStyleBG + ' ' + chartTitleStyleText + ' } ' +
                    '#' + thisWidget.jqElementId + '.widget-chart-title-text { ' + chartTitleStyle + ' }' +
                    //    '#' + thisWidget.jqElementId + '.focus .widget-timeSeriesChartV2 {' + chartFocusBorder + '}' +
                    '#' + thisWidget.jqElementId + '.widget-timeSeriesChartV2 {' + chartBackground + chartBorder + '}';
            }

            return styleBlock;

        };

        this.afterRender = function () {
            widgetProperties = thisWidget.properties;
            widgetContainer = thisWidget.jqElementId;
            widgetContainerId = '#' + thisWidget.jqElementId;
            chartContainer = widgetContainer + '-chart'; //root_nvd3line-6-chart
            chartContainerId = '#' + chartContainer; //#root_nvd3line-6-chart

            widgetSelector = widgetContainer + ' .-element';
            // add svg tag to html element required to inject chart
            $('<svg id="' + chartContainer + '" ></svg>').appendTo(widgetContainerId);

            // styles
            var chartTitleElement = $(widgetContainerId).find('.chart-title');
            chartTitleElement.switchClass('textsize-normal', chartTitleTextSizeClass);

            // events
            $(widgetSelector).on('focus', function () {
                $(widgetContainer).addClass('focus');
            });

            $(widgetSelector).on('blur', function (e) {
                $(widgetContainer).removeClass('focus');
            });

            thisWidget.jqElement.dblclick(thisWidget.dblClickHandler);

            thisWidget.jqElement.find('.nv-legend').bind('click', function (e) {
                thisWidget.jqElement.triggerHandler('DoubleClicked');
                e.preventDefault();
            });

            if (thisWidget.properties.ResponsiveLayout) {
                isResponsive = true;
                $(widgetContainerId + '-bounding-box').height('100%').width('100%');
                $(widgetContainerId + '-bounding-box').css('overflow','hidden');
                $(widgetContainerId).height("100%").width("100%");
                $(chartContainerId).height("100%").width("100%");
                $(widgetContainerId).css('overflow','hidden');
            } else {
                $(chartContainerId).width(thisWidget.width + 20);
                $(chartContainerId).height(thisWidget.height - 22);
            }

            $(widgetContainerId + '-bounding-box').css('z-index',thisWidget.zIndex);
            
            // get unbound dataLabel strings
            for (var i = 1; i < thisWidget.nSeries + 1; i++) {
                var dataLabel = widgetProperties['DataLabel' + i];
                if (dataLabel !== undefined && dataLabel !== '') {
                    dataLabels.push(dataLabel);
                } else {
                    dataLabels.push("Series " + i);
                }
            }

            dataLabels = this.forceUniqueValues(dataLabels);
            // build empty chart if no data event is received
            emptyChart = setTimeout(function(){thisWidget.showEmptyChart("Bar Chart Must Be Bound To Data")}, 20000);

        };

        this.updateProperty = function (updatePropertyInfo) {
            var thisWidget = this;
            var widgetProperties = thisWidget.properties;
            var seriesNumber;
            var nSeries = thisWidget.nSeries;
            if (updatePropertyInfo.TargetProperty === "ChartTitle") {
                var updatedTitle = updatePropertyInfo.RawSinglePropertyValue;
                thisWidget.setProperty('ChartTitle', updatedTitle);
                thisWidget.title = updatedTitle;
                $('#' + thisWidget.jqElementId + '-title').text(updatedTitle);
                return;
            }
            // in progress: for binding dataLabel
            if (updatePropertyInfo.TargetProperty.indexOf('DataLabel') === 0) {
                for (seriesNumber = 1; seriesNumber <= nSeries; seriesNumber++) {
                    labelName = 'DataLabel' + seriesNumber.toString();
                    if (updatePropertyInfo.TargetProperty === labelName) {
                        thisWidget.setProperty(labelName, updatePropertyInfo.RawSinglePropertyValue);
                        // replace the dataLabel by position in array dataLabels
                        dataLabels[seriesNumber-1] = thisWidget.getProperty(labelName);
                        dataLabels = this.forceUniqueValues(dataLabels);
                        liveData[seriesNumber-1].key = dataLabels[seriesNumber-1];
                    }
                }
            }
            // if this is in a inactive tab or similar we must prevent rendering until tab gets clicked
            if(isResponsive && $(widgetContainerId).closest('.tabsv2-actual-tab-contents').css('display')==='none') {
                isInHiddenTab = true;
                $(chartContainerId).hide();
            }else{
                isInHiddenTab = false;
                $(chartContainerId).fadeIn(thisWidget.duration);
            }
            if (updatePropertyInfo.TargetProperty.indexOf('Data') === 0 && !isInHiddenBrowserTab && thisWidget.processing === false) {
                clearTimeout(emptyChart);
                dataRows = updatePropertyInfo.ActualDataRows;

                if(dataRowsNum === undefined && stackable === true) {
                    dataRowsNum = dataRows.length;
                }else{
                    stackable = dataRowsNum === dataRows.length;
                }

                // iterate through the series fields
                if (updatePropertyInfo.TargetProperty === "Data") {
                    chartSeries = [];
                    for (seriesNumber = 1; seriesNumber <= nSeries; seriesNumber++) {

                        var dataField = widgetProperties['DataField' + seriesNumber];

                        if (dataField !== undefined && dataField !== '' && dataRows != undefined && dataRows.length !== 0) {

                            var seriesType = widgetProperties['SeriesType' + seriesNumber];

                            if (seriesType == 'chart' || seriesType === undefined || seriesType == null) {
                                seriesType = widgetProperties['ChartType'];
                            }

                            this.enableSelection = widgetProperties['AllowSelection'];

                            //var seriesmarkerType = widgetProperties['SeriesMarkerType' + seriesNumber];
                            //if (seriesmarkerType === undefined || seriesmarkerType == 'chart')
                            //   seriesmarkerType = widgetProperties['MarkerType'];

                            var seriesDefinition = {
                                dataSource: updatePropertyInfo.TargetProperty,
                                type: seriesType,
                                field: dataField,
                                data: dataRows,
                                label: this.getProperty('DataLabel' + seriesNumber),
                                style: widgetProperties['SeriesStyle' + seriesNumber]
                            };

                            chartSeries.push(seriesDefinition);
                        }
                    }
                } else {
                    // multiple datasource handling
                    if (dataRows.length > 0 && !thisWidget.singleDataSource) {

                        dataRowsNum === undefined ? dataRowsNum = dataRows.length : stackable = dataRowsNum === dataRows.length;
                        
                        // each data load resets the purge timeout
                        // so we only purge after final data load in case some dataSources were deselected
                        // clearTimeout(purge);
                        // purge = setTimeout(function(){purgeDataSources(dataSourceId)}, 300);
                        var dataSourceName = updatePropertyInfo.TargetProperty;

                        //check if targetProperty is a dataSource already displayed
                        var newSeries = true;

                        var dataSourceId = dataSourceName.substr(dataSourceName.length - 1, 1);
                        for (var i = 0; i < chartSeries.length; i++) {
                            if (chartSeries[i].dataSource === updatePropertyInfo.TargetProperty || dataSourceId > nSeries) {
                                newSeries = false;
                            }
                        }

                        var dataField = widgetProperties['DataField' + dataSourceId];

                        var seriesDefinition = {
                            dataSource: dataSourceName,
                            id: dataSourceId,
                            field: dataField,
                            data: dataRows,
                            label: this.getProperty('DataLabel' + dataSourceId),
                            style: widgetProperties['SeriesStyle' + dataSourceId]
                        };

                        // if existing dataSource update, update
                        if (newSeries === false) {
                            chartSeries.splice(dataSourceId - 1, 1, seriesDefinition);
                        }

                        // if new dataSource, add
                        if (newSeries === true) {
                            chartSeries.push(seriesDefinition);
                        }

                        // if max series already displayed, drop FIFO
                        if (chartSeries.length > nSeries) {
                            //console.log("fifo "+thisWidget.jqElementId+" chartSeries length: "+chartSeries.length+" nSeries: "+nSeries);
                            chartSeries.shift();
                        }
                    }
                }
                if(! isInHiddenTab) {
                    liveData = this.processDataset();
                }
            }


            if(thisWidget.enableSelection) {

                var selectedRowIndices = updatePropertyInfo.SelectedRowIndices;

                if (selectedRowIndices !== undefined) {
                    //this is chart updating selection flags to match grid row
                    //TW.ChartLibrary.handleChartSelectionUpdate(this, this.chart, updatePropertyInfo.TargetProperty, selectedRowIndices);
                }
                else {
                    TW.ChartLibrary.handleChartSelectionUpdate(this, this.chart, updatePropertyInfo.TargetProperty, new Array());
                }
            }
        };

        function purgeDataSources(dataSourceId){
            if(chartSeries.length > dataSourceId) {
                //console.log("purge "+thisWidget.jqElementId+" chartSeries length: "+chartSeries.length+" dataSourceId: "+dataSourceId);
                chartSeries.splice(dataSourceId, (chartSeries.length - dataSourceId));
                if(! isInHiddenTab) {
                    liveData = this.processDataset();
                }
            }
        }

        this.processDataset = function () {
            var nRows = 0,
            seriesFieldName,
            xAxisField,
            nSeries = thisWidget.nSeries,
            singleDataSource = thisWidget.singleDataSource;
            returnData = [];
            thisWidget.processing = true;
            var nSeriesToProcess = singleDataSource ? nSeries : chartSeries.length;

            nSeriesToProcess === 1 ? thisWidget.barType = 'discrete' : thisWidget.barType = 'multi';

            for (var i = 0; i < nSeriesToProcess; i++) {
                
                var dataSource = chartSeries[i];
                
                xAxisField = singleDataSource ? thisWidget.xAxisField : thisWidget['xAxisField' + chartSeries[i].id];
                
                if(dataSource !== undefined) {
                    seriesFieldName = dataSource.field;
                    var data = dataSource.data;
                }else{
                    var message = "All series must have a " + ( singleDataSource ? "DataField" : "DataSource")+" set";
                    TW.log.error(message);
                    return;
                }

                if (seriesFieldName !== undefined && seriesFieldName != "") {
                    var barLabel = "",
                    seriesValue,
                    seriesValues = [],
                    obj,
                    offset;
                    barLabels = [];
                    nRows = data.length;

                    for (var rowid = 0; rowid < nRows; rowid++) {
                        if(offset===undefined) {
                            offset = Math.max(1, rowid);
                        }
                        var row = data[rowid];
                        /*
                         for (var key in row) {
                         // check also if property is not inherited from prototype
                             if (row.hasOwnProperty(key)) {
                             console.log("key: "+key);
                             var value = row[key];
                             console.log("value: "+value);
                             }
                         }
                    */
                        if (row[seriesFieldName] !== undefined && row[seriesFieldName] !== '') {
                            seriesValue = row[seriesFieldName];
                        } else {
                            TW.log.warn("undefined or empty seriesValue forced to 0");
                            seriesValue = 0;
                        }
                        if (xAxisField !== undefined && row[xAxisField] !== undefined && row[xAxisField] !== '') {
                            barLabel = row[xAxisField];
                            //console.log("field-based barLabel: "+barLabel);
                        }else{
                            barLabel = rowid + offset;
                            //console.log("position-based barLabel: "+barLabel);
                        }
                        // for series this only pushes per group not per record
                        barLabels.push(barLabel);
                        obj = {"x": rowid+offset, "y": seriesValue};
                        //console.log("obj.x: "+obj.x+" obj.y: "+obj.y);
                        //console.log("pds obj.y: " + obj.y);
                        seriesValues.push(obj);
                    }

                    var seriesData = {
                        'values': seriesValues,
                        // key should be label prop w fallback to dataSourceName
                        'key': TW.Runtime.convertLocalizableString(dataLabels[i]),
                        'color': chartStyles['series' + (i + 1)]
                    };

                    returnData.push(seriesData);
                }
            }
            if (returnData.length > 0 && !isInHiddenTab) {
                if(chartData){
                    $(chartContainerId).show();
                    thisWidget.update(returnData);
                }else {
                    thisWidget.render(returnData);
                }
                thisWidget.processing = false;
                return returnData;
            }
        };

        this.resize = function(width,height) {
            if ($(widgetContainerId).closest('.tabsv2-actual-tab-contents').css('display')==='block' && isInHiddenTab) {
                isInHiddenTab = false;
                thisWidget.processDataset();
                $(chartContainerId).fadeIn(thisWidget.duration);
            }
        };

        this.render = function (data, isUpdate) {
            var propMargin = thisWidget.margins.split(',');
            var xLabelMargin = (isResponsive ? 42 : 42) + propMargin[2] * 1;
            var yLabelMargin = 21 + propMargin[1] * 1;
            var legendMargin = 21 + propMargin[0] * 1;
            var showLegend = thisWidget.showLegend === true && thisWidget.nSeries > 1;
            var chartTemplate = "discreteBarChart";

            if (data === undefined) {
                thisWidget.showEmptyChart("DATA UNDEFINED");
                return;
            }

            if (isUpdate !== undefined && isUpdate === true) {
                chartData.datum(data).transition().duration(thisWidget.duration).call(chart);
                if(!resizeHandler){
                    resizeHandler = nv.utils.windowResize(chart.update);
                }
            } else {
                nv.addGraph(function() {
                if(thisWidget.nSeries && thisWidget.showValues){
                    chart = nv.models.discreteBarChart();
                    // unsupported option that would otherwise be expected here
                    //chart.showLegend(false);
                    chart.showValues(thisWidget.showValues);
                    chart.valueFormat(d3.format(',.'+thisWidget.precision+'f'));
                    chart.color([chartStyles.series1]);
                }else{
                    chartTemplate = "multiBarChart";
                    chart = nv.models.multiBarChart();
                    chart.rotateLabels(thisWidget.labelAngle);
                    chart.groupSpacing(0.1);
                    if(chartSeries.length===1){
                        chart.showXAxisLabels = (thisWidget.showAxisLabels);
                        chart.color([chartStyles.series1]);
                        chart.showLegend(false);
                        stackable = false;
                    }else{
                        chart.showLegend(thisWidget.showLegend);
                    }
                }
                    chart.tooltip.enabled(thisWidget.enableHover);
                    chart.xAxis.tickFormat(d3.format(','))
                        .showMaxMin(false)//(!!thisWidget.xAxisMinMaxVisible)
                        .ticks(thisWidget.xAxisIntervals)
                        .tickPadding(15);
                    chart.xAxis.ticks(data[0].values.length)
                            .tickFormat(function(d){return barLabels[d-1]});

                    chart.showXAxisLabels = (thisWidget.showXAxisLabels);
                    chart.duration(thisWidget.duration);

                    chart.yAxis.tickFormat(d3.format('.02f'))
                        .showMaxMin(!!thisWidget.yAxisMinMaxVisible);
                    thisWidget.yAxisIntervals==="per" ? chart.yAxis.ticks(data[0].values.length): chart.yAxis.ticks();    
                    // set the y scale to user settings
                    if (thisWidget.autoScale === false && thisWidget.yAxisMinimum !== '') {

                        if (thisWidget.yAxisMaximum > thisWidget.yAxisMinimum) {
                            chart.forceY([thisWidget.yAxisMinimum, thisWidget.yAxisMaximum]);
                        }
                        else {
                            chart.forceY(thisWidget.yAxisMinimum);
                        }
                    }

                    // add margin if legend displayed
                    if (showLegend) {
                        legendMargin += 7;
                    }

                    chart.showXAxis(thisWidget.showXAxisLabels);
                    chart.showYAxis(thisWidget.showYAxisLabels);

                    if (thisWidget.showYAxisLabels === true) {
                        yLabelMargin += 50; //ideally use actual values width
                    }

                    if (thisWidget.showXAxisLabels === true) {
                        yLabelMargin += isResponsive ? 0 : 0;
                        xLabelMargin += isResponsive ? 21 : 14;
                    }

                    if (thisWidget.showAxisLabels === true) {
                        if (chartTemplate === "multiBarChart") {
                            chart.xAxis.axisLabel(thisWidget.xAxisLabel);
                        }
                        chart.yAxis.axisLabel(thisWidget.yAxisLabel);
                        xLabelMargin += isResponsive ? 21 : 7;
                    }

                    chart.margin({top: legendMargin+(propMargin[0]*1), left: yLabelMargin, bottom: xLabelMargin, right: 40+(propMargin[3]*1)});
                    if(chartTemplate==="discreteBarChart" && thisWidget.showAxisLabels) {
                        d3.select(chartContainerId).append("text")
                            .attr("x", $(chartContainerId).width() / 2)
                            .attr("y", $(chartContainerId).height() -28)
                            .attr("class", "nv-axislabel")
                            .style("text-anchor", "middle")
                            .text(thisWidget.xAxisLabel);
                    }

                    // override default tooltip in interactive layer
                    if(thisWidget.enableHover) {
                        chart.tooltip.contentGenerator(function (d) {
                            return thisWidget.tooltipGenerator(d)
                        });
                    }
                    chartData = d3.select(widgetContainerId+'-chart')
                        //.datum(exampleData())
                        .datum(data)
                        .call(chart);

                    if(!stackable){
                        $(widgetContainerId).find('.nv-controlsWrap').css('display', 'none');
                    }

                    //d3.selectAll(".tick text").call(thisWidget.wrap, 100);
                    d3.selectAll(widgetContainerId+'-chart text')

                        .style("fill", chartStyles.text)
                        .style("font-weight",chartStyles.axisFontWeight);
                    d3.selectAll(widgetContainerId+'-chart line')
                        .style("stroke", chartStyles.gridStyle);

                    chart.dispatch.on('renderEnd', function(){
                        //console.log('Chart '+thisWidget.jqElementId+' Render Complete');
                        chart.tooltip.enabled(false);
                        updateStyles()
                    });

                    //return chart;
                });

            }

            /* test data for multibar
            function exampleData(){
                return[
                    {
                        key: "S1",
                        color: "#51A351",
                        values:
                            [
                                { x : "A", y : 40 },
                                { x : "B", y : 30 },
                                { x : 5,   y : 20 }
                            ]
                    },
                    {
                        key: "S2",
                        color: "#BD362F",
                        values:
                            [
                                { x : "A", y : 60 },
                                { x : "B", y : 50 },
                                { x : 5,   y : 70 }
                            ]
                    }
                ];
            }
            */

            /* test data for discreteBar
             function exampleData() {
             return  [
                 {
                     key: "Cumulative Return",
                     color: "#BD362F",
                     values: [
                         {
                             "label": "A Label",
                             "value": 29.765957771107
                         },
                         {
                             "label": "B Label",
                             "value": 12
                         }
                     ]
                 }
             ]
             }
             */


            // triggered by legend click
            function updateStyles() {
                setTimeout(function () {
                    doUpdateStyles();
                }, thisWidget.duration);
            }

            function doUpdateStyles() {
                //d3.selectAll(".tick text").call(thisWidget.wrap, 100);
                d3.selectAll(widgetContainerId+'-chart text')
                    .style("fill", chartStyles.text);
                d3.selectAll(widgetContainerId+'-chart line')
                    .style([{"stroke":chartStyles.gridStyle}]);
                chart.tooltip.enabled(thisWidget.enableHover);
            }
        };

        this.update = function (data){
            // Update the SVG with the new data and call chart
            chartData.datum(data).transition().duration(500).call(chart);
            if(!resizeHandler){
                resizeHandler = nv.utils.windowResize(chart.update);
            }
        };

        this.wrap = function(text, width) {
            text.each(function() {
                var text = d3.select(this),
                    words = text.text().split(/\s+/).reverse(),
                    word,
                    line = [],
                    lineNumber = 0,
                    lineHeight = 1.1, // ems
                    y = text.attr("y"),
                    dy = parseFloat(text.attr("dy")),
                    tspan = text.text(null).append("tspan").attr("x", 0).attr("y", y).attr("dy", dy + "em");
                while (word = words.pop()) {
                    line.push(word);
                    tspan.text(line.join(" "));
                    if (tspan.node().getComputedTextLength() > width) {
                        line.pop();
                        tspan.text(line.join(" "));
                        line = [word];
                        tspan = text.append("tspan").attr("x", 0).attr("y", y).attr("dy", ++lineNumber * lineHeight + dy + "em").text(word);
                    }
                }
            });
        };

        this.dblClickHandler = function(){
            thisWidget.jqElement.triggerHandler('DoubleClicked');
        };

        this.showEmptyChart = function(message) {
            TW.log.warn(message);
            /*
            var chartWidgetPos = $(widgetContainerId).offset();
            d3.select(chartContainerId).append("rect")
                .attr({"class": "tick", "id": chartContainer+"_chartBorder"})
                .attr({"x": chartWidgetPos.left, "y": chartWidgetPos.top, "width": $(widgetContainerId).width(), "height": $(widgetContainerId).height()})
                .style({"fill": "gray", "stroke": chartStyles.gridStyle});
            var label1 = Encoder.htmlEncode('Okay');
            var button1default = widgetProperties['DefaultConfirmationButton'] === 'button1';
            var button1cancel = true;
            var buttons = {};

            buttons[label1] = {
                'class': 'blue',
                'action': function () {
                    if (!button1cancel) {
                        thisWidget.jqElement.triggerHandler('Clicked');
                    }
                },
                'default': button1default
            };

            $.confirm({
                'title': Encoder.htmlEncode('BarChart Configuration'),
                'message': Encoder.htmlEncode(message),
                'buttons': buttons
            });
            */
        };

        // this probably has to be run mutiple times due to dataLabel being  a dynamic runtime property
        // check for duplicate datalabels and append numeric suffix if needed
        this.forceUniqueValues = function (dataLabels) {
            var data = dataLabels,
                result = data.map(function (item) {
                    return this[item].count === 1 ? item : item + '-' + ++this[item].index;
                }, data.reduce(function (retVal, item) {
                    retVal[item] = retVal[item] || {count: 0, index: 0};
                    retVal[item].count++;
                    return retVal;
                }, {}));
            return result;
        };

        //Format function for the tooltip values column
        this.valueFormatter = function(d,i) {
            return d;
        };

        //Format function for the tooltip header value.
        this.headerFormatter = function(d) {
            return d;
        };

        this.keyFormatter = function(d, i) {
            return d;
        };

        this.tooltipGenerator = function(d) {
            var headerEnabled = true;
            if (d === null) {
                return '';
            }

            var table = d3.select(document.createElement("table"));
            if (headerEnabled) {
                var theadEnter = table.selectAll("thead")
                    .data([d])
                    .enter().append("thead");

                theadEnter.append("tr")
                    .append("td")
                    .attr("colspan", 3)
                    .append("strong")
                    .classed("x-value", true)
                    //.html(headerFormatter(d.value)); // default is to use x value, which has no meaning
                    // use x-axis label, assume it id's "something" in quantity of something
                    .html(thisWidget.headerFormatter(thisWidget.xAxisLabel));
            }

            var tbodyEnter = table.selectAll("tbody")
                .data([d])
                .enter().append("tbody");

            var trowEnter = tbodyEnter.selectAll("tr")
                .data(function(p) { return p.series})
                .enter()
                .append("tr")
                .classed("highlight", function(p) { return p.highlight});

            trowEnter.append("td")
                .classed("legend-color-guide",true)
                .append("div")
                .style("background-color", function(p) { return p.color});

            trowEnter.append("td")
                .classed("key",true)
                .html(function(p, i) {return thisWidget.keyFormatter(barLabels[p.key], i)});

            trowEnter.append("td")
                .classed("value",true)
                .html(function(p, i) { return thisWidget.valueFormatter(p.value, i) });


            trowEnter.selectAll("td").each(function(p) {
                if (p.highlight) {
                    var opacityScale = d3.scale.linear().domain([0,1]).range(["#fff",p.color]);
                    var opacity = 0.6;
                    d3.select(this)
                        .style("border-bottom-color", opacityScale(opacity))
                        .style("border-top-color", opacityScale(opacity))
                    ;
                }
            });

            var html = table.node().outerHTML;
            if (d.footer !== undefined)
                html += "<div class='footer'>" + d.footer + "</div>";
            return html;

        };

        //single item selection support to start off
        this.setSeriesSelection = function() {
            selectedRowIndices = [];
            //var selectedRowIndices = updatePropertyInfo.SelectedRowIndices;
            selectedRowIndices.push(clickedRowId);
            thisWidget.updateSelection('Data', selectedRowIndices);
        };

        this.beforeDestroy = function () {
            try {
                thisWidget.jqElement.unbind();
            } catch (err) {
                TW.log.error('Error in TW.Runtime.Widgets.button.beforeDestroy', err);
            }
        };

    };
}());
